# Find duplicate files. (c) Peter Kankowski, 2009. http://www.strchr.com

import os, sys, codecs, filecmp, time
from os.path import join, getsize
DIRECTORY = 'c:\\Docum'

def raise_err(err):
    if type(err) == WindowsError and err.args[0] == 5: # ERROR_ACCESS_DENIED
        return
    raise err

# Print on Windows console (replacing non-encodable characters).
# See http://bugs.python.org/issue5110
def print_win(s):
    r = s.encode(sys.stdout.encoding, 'backslashreplace')
    print(codecs.getdecoder(sys.stdout.encoding)(r)[0])





starttime = time.clock()

# Find files with the same size
samesize = {}
for path, _, filenames in os.walk(DIRECTORY, onerror=raise_err):
    for filename in filenames:
        fullname = join(path, filename)
        samesize.setdefault(getsize(fullname), []).append(fullname)

# Compare them
for filenames in samesize.values():
    if len(filenames) > 1:
        equal = {}
        equalr = {}
        for i, filename in enumerate(filenames):
            if filename not in equal:
                for filename2 in filenames[i+1:]:
                    if filecmp.cmp(filename, filename2, False):
                       equal[filename2] = True
                       equalr.setdefault(filename, [filename]).append(filename2)
        
        # Print equal files
        for files in equalr.values():
            if len(files) > 1:
                print_win('\n'.join(files) + '\n')

print( "{0:.2f} seconds".format(time.clock() - starttime) )
